using Unity.Jobs;
using UnityEngine;

public class TerrainChunkerJobs : TerrainChunker
{
    [Header("Autogenerated values")]
	private ShapeGeneratorJob shapeGenerator;
    private JobHandle runningShape;

    protected override bool CheckIfFinished()
    {
        return runningShape.IsCompleted;
    }

    protected override bool CheckIfCancelled()
    {
        return shapeGenerator.Cancelled;
    }

    //protected override void CancelRunning()
    //{
    //    //// Cancel thread if its running.
    //    //shapeGenerator.Cancel(runningShape);
    //    //print($"{gameObject.name} has running job, which has been cancelled.");
    //}

    protected override void CreateRunning()
    {
        shapeGenerator = new(crawlOffset, gridPosition, heightResolution,
            heightScale, master.octaves);
        runningShape = shapeGenerator.Schedule();
    }

    protected override float[,] RetrieveFromRunning()
    {
        runningShape.Complete();
        return shapeGenerator.Retrieve();
    }

    protected override void CleanUp()
    {
        shapeGenerator.Cancel(runningShape);
    }
}