using System.Threading;
using UnityEngine;

public class TerrainChunkerThreads : TerrainChunker
{
    private ShapeGeneratorThread shapeGenerator;
    //private ThreadStart shapeStart;
    private Thread shapeThread;
    private CancellationTokenSource cts;
    protected override bool CheckIfFinished()
    {
        return shapeThread == null || !shapeThread.IsAlive;
    }

    protected override bool CheckIfCancelled()
    {
        return shapeGenerator.Cancelled;
    }
    
    //protected override void CancelRunning()
    //{
    //    cts.Cancel();
    //}

    protected override void CreateRunning()
    {
        cts = new();

        shapeGenerator = new(crawlOffset, gridPosition, heightResolution,
            heightScale, master.octaves, cts.Token);
        ThreadStart shapeStart = new(shapeGenerator.Generate);
        shapeThread = new(shapeStart);
        shapeThread.Start();
    }

    protected override float[,] RetrieveFromRunning()
    {
        return shapeGenerator.Retrieve();
    }

    protected override void CleanUp()
    {
        
    }
}